 
/*
 *  Access IO Test Program 
 *
 */
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <ctype.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <signal.h>

#include <pthread.h>   // for nanosleep() call

#include "aioUsbApi.h"


int   devIdx;
char  anyKey;
int   ctlC;
aioDeviceInfo aioDevices;

#define MAX_ROW 25
#define MAX_COL 70

struct timespec      bulkPollTime;

void
catchInterrupt (int signum) 
{
    ctlC = 1;
}



int 
getFunction()
{
  
   unsigned char val; 
   int validInput; 
   

   ctlC = 0;


    printf ("\33[2J\n"); // clear screen

    printf("\33[8;5H\n ");
    printf ("\33[9;20H===================================================\n"); 
    printf ("\33[10;20H       ACCES/IO Digital Slow Port IO Sample       \n"); 
    printf ("\33[11;20H              USB-DIO-16* Product Family          \n");
    printf ("\33[12;20H===================================================\n"); 

     printf("\n\n");
     printf("                 IMPORTANT : Please read the  note below, or you can\n");
     printf("                             damage your product !!!             \n\n"); 
     printf("            Be certain that you are NOT connecting signals that will cause\n");
     printf("            bus contention (outputs to outputs) before you proceed !\n\n");

     printf("\n\n");
     printf("             This sample allows you to specify data for the slow outputs ports of the board \n");
     printf("             or monitor their inputs. The fast-DIO bus is not used                          \n"); 
     printf("\n\n");



          printf("                       1)  Control Outputs             \n"); 
          printf("                       2)  Read Inputs                 \n"); 
          printf("                       3)  Exit                        \n");


     validInput = 0;
     while (!validInput)
     {
       printf("Enter Selection : "); 
       scanf ("\n%c",&val);

       if  (  (val == '1')  || 
              (val == '2')  || 
              (val == '3') ) 
      {
         validInput = 1;
      }
      else
      {
         validInput = 0;
         printf("\nInvalid input. \n");
      }
    }

     printf("\n\n");
     return val;

}



int main()
{

  int            i; 
  int            devIdx; 
  int            devFound; 
  int            ret;
  unsigned char  mask;
  unsigned char  data[4];
  int            Aconfig;
  int            Bconfig;
  int            Cconfig;
  int            Dconfig;
  int            triState;
  int            tristateA;
  int            tristateBCD;
  int	 	 key;
  int            input;

  // This ABSOLUTELY POSITIVELY MUST be called BEFORE any other function in the API
  // is called or bad things will happen (Segmentation Violation)
  //
  AIO_Init();

  // This should called BEFORE any other function in the API
  // to populate the list of Acces devices
  ret = AIO_Usb_GetDevices(&aioDevices);

  // find the first DIO-16 device
  devFound = 0;
  for (i = 0; i < MAX_USB_DEVICES;i++)
  {
    if ( (aioDevices.aioDevList[i].productId == USB_DIO_16H) ||
         (aioDevices.aioDevList[i].productId == USB_DI_16A)  ||
         (aioDevices.aioDevList[i].productId == USB_DO_16A)  ||
         (aioDevices.aioDevList[i].productId == USB_DIO_16A)    )
    {
      devIdx = aioDevices.aioDevList[i].devIdx;
      devFound = 1; 
    }
  }
  if ( devFound == 0)
  {
     printf("No DIO_16 or DO_16 devices found \n");
     return 0;
   } 

 while (1)
 {
  switch (getFunction() ) 
  {

   case '1':
   {
     int validInput = 0;

      validInput = 0;
      while (!validInput)
      {
        printf("  Port A Tristate :  '0'= no  '1'= yes    : ");
        scanf ("%x",&tristateA);
        
        if  ( (tristateA ==  0) ||  (tristateA == 1) ) 
          validInput = 1;
        else
        {
          printf("\nInvalid Input. \n");
          validInput = 0;
        }
      }

      validInput = 0;
      while (!validInput)
      {
        printf("  Port BCD Tristate :  '0'= no  '1'= yes  : ");
        scanf ("%x",&tristateBCD);
        
        if  ( (tristateBCD ==  0) ||  (tristateBCD == 1) ) 
          validInput = 1;
        else
        {
          printf("\nInvalid Input. \n");
          validInput = 0;
        }
      }


      printf("\n");
      printf("  Ports A,B,C configured as outputs\n");
      printf("  D is always opposite of C so it is an input \n");


      // The least significant bit tristates Port-A
      // The next least significant bit tristates Port B,C,D
      // 
      triState = 0;
      triState = triState | tristateA;
      triState = triState | (tristateBCD << 1);

      Aconfig = 1;
      Bconfig = 1;
      Cconfig = 1;
      Dconfig = 0;   // opposite of C

      mask = 0;
      mask = mask | Aconfig;
      mask = mask | (Bconfig << 1);
      mask = mask | (Cconfig << 2);
      mask = mask | (Dconfig << 3);

      printf("\n");




      validInput = 0;
      while (!validInput)
      {
       printf("  Enter data byte (hex, 0x00 - 0xFF) for port A              : "); 
       scanf ("%x",&input);

        
       //if  ( (input >=  0) && (input <= 0xFF) && (!isalnum(input)) ) 
       if  ( (input >=  0) && (input <= 0xFF) )
         validInput = 1;
       else
       {
          printf("\nInvalid Input. Valid values are any hex number\n");
          validInput = 0;
       }
      } 
      data[0] = input;

      validInput = 0;
      while (!validInput)
      {
       printf("  Enter data byte (hex, 0x00 - 0xFF) for port B              : "); 
       scanf ("%x",&input);

        
       //if  ( (input >=  0) && (input <= 0xFF) && (!isalnum(input)) ) 
       if  ( (input >=  0) && (input <= 0xFF)  ) 
         validInput = 1;
       else
       {
          printf("\nInvalid Input. Valid values are any hex number\n");
          validInput = 0;
       }
      } 
      data[1] = input;

      validInput = 0;
      while (!validInput)
      {
       printf("  Enter data byte (hex, 0x00 - 0xFF) for port C              : "); 
       scanf ("%x",&input);

        
       //if  ( (input >=  0) && (input <= 0xFF) && (!isalnum(input)) ) 
       if  ( (input >=  0) && (input <= 0xFF) ) 
         validInput = 1;
       else
       {
          printf("\nInvalid Input. Valid values are any hex number\n");
          validInput = 0;
       }
      } 
      data[2] = input;





      // port D not used for this case 
      data[3] = 0;

      ret =   AIO_Usb_DIO_ConfigureEx(devIdx,
                                      &mask,
                                      data,   
                                      triState);

     if (ret > ERROR_SUCCESS)
     {
      printf ("\nDIO_ConfigureEx Failed  dev=%d err=%d \n",(unsigned int)devIdx,ret);
      return (0); 
     }

     break;
    }

   case '2':
   {
      int validInput;

      validInput = 0;
      while (!validInput)
      {
        printf("  Port A Tristate :  '0'= no  '1'= yes    : ");
        scanf ("%x",&tristateA);
        
        if  ( (tristateA ==  0) ||  (tristateA == 1) ) 
          validInput = 1;
        else
        {
          printf("\nInvalid Input. \n");
          validInput = 0;
        }
      }

      validInput = 0;
      while (!validInput)
      {
        printf("  Port BCD Tristate :  '0'= no  '1'= yes  : ");
        scanf ("%x",&tristateBCD);
        
        if  ( (tristateA ==  0) ||  (tristateA == 1) ) 
          validInput = 1;
        else
        {
          printf("\nInvalid Input. \n");
          validInput = 0;
        }
      }

      printf("\n");

      printf("  Ports A,B,C configured as inputs \n");
      printf("  D is always opposite of C so it is an ouput \n");
      printf("\n\n");

      // The least significant bit tristates Port-A
      // The next least significant bit tristates Port B,C,D
      // 
      triState = 0;
      triState = triState | tristateA;
      triState = triState | (tristateBCD << 1);

      Aconfig = 0;
      Bconfig = 0;
      Cconfig = 0;
      Dconfig = 1;   // opposite of C

      mask = 0;
      mask = mask | Aconfig;
      mask = mask | (Bconfig << 1);
      mask = mask | (Cconfig << 2);
      mask = mask | (Dconfig << 3);


      ret =   AIO_Usb_DIO_ConfigureEx(devIdx,
                                      &mask,
                                      data,   
                                      triState);

     if (ret > ERROR_SUCCESS)
     {
      printf ("\nDIO_ConfigureEx Failed  dev=%d err=%d \n",(unsigned int)devIdx,ret);
      return (0); 
     }

      ret =   AIO_Usb_DIO_ReadAll (devIdx,
                                   (unsigned char *)&data[0]); 

      if (ret > ERROR_SUCCESS)
      {
        printf ("\n\nReadAll Failed dev=0x%0x err=%d  \n\n",(unsigned int)devIdx,ret);
        break;
      }


      printf("\t\tPort A :  0x%x\n",data[0]);
      printf("\t\tPort B :  0x%x\n",data[1]);
      printf("\t\tPort C :  0x%x\n",data[2]);

      printf("\n");
      printf("  Presss the ANY key to continue ");
      key  = getchar(); 
      key  = getchar(); 
      break;
    }



   case '3':
   {
    return 0;
   }

   default :
    break;
  } 

  } // while 

  } // main 
