 /*
 *  Access IO Test Program 
 *
 */
#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <signal.h>

#include <pthread.h>   // for nanosleep() call

#include "aioUsbApi.h"


int   devIdx;
char  anyKey;
int   ctlC;
aioDeviceInfo aioDevices;

#define MAX_ROW 25
#define MAX_COL 70

struct timespec      bulkPollTime;

void
catchInterrupt (int signum) 
{
    ctlC = 1;
}



int
getFunction()
{
  
   int validInput; 
   ctlC = 0;

   unsigned char val; 

    printf ("\33[2J\n"); // clear screen

    printf("\33[8;5H\n ");
    printf ("\33[9;20H===================================================\n"); 
    printf ("\33[10;20H       ACCES I/O USB  Sample Program \n"); 
    printf ("\33[11;20H           USB-IDIO Product Family                \n");
    printf ("\33[12;20H===================================================\n"); 

     printf("             This sample allows you to specify data for 2 of the input ports \n");
     printf("             of the board  and displays their 4 output ports\n"); 
     printf("\n\n");

     printf("                       1)  Control Outputs             \n"); 
     printf("                       2)  Read Inputs                 \n"); 
     printf("                       3)  Exit                        \n");

     validInput = 0;
     while (!validInput)
     {
       printf("Enter Selection : "); 
       scanf ("\n%c",&val);

       if  (  (val == '1')  || 
              (val == '2')  || 
              (val == '3') ) 
      {
         validInput = 1;
      }
      else
      {
         validInput = 0;
         printf("\nInvalid input. \n");
      }
    }
 
     printf("\n\n");
     return val; 
}



int main()
{

  int            i; 
  int            devIdx; 
  int            devFound; 
  int            ret;
  unsigned char  data[4];
  int	 	 key;
  int		 input;        

  // This ABSOLUTELY POSITIVELY MUST be called BEFORE any other function in the API
  // is called or bad things will happen (Segmentation Violation)
  //
  AIO_Init();

  // This should called BEFORE any other function in the API
  // to populate the list of Acces devices
  ret = AIO_Usb_GetDevices(&aioDevices);

  // find the first IDIO* device
  devFound = 0;
  for (i = 0; i < MAX_USB_DEVICES;i++)
  {
    if  (    (aioDevices.aioDevList[i].productId == USB_IIRO_16_DEV )     ||
             (aioDevices.aioDevList[i].productId == USB_IIRO4_2SM_DEV )   ||
             (aioDevices.aioDevList[i].productId == USB_IDIO_16)    )
    {
      devIdx = aioDevices.aioDevList[i].devIdx;
      devFound = 1; 
    }
  }
  if ( devFound == 0)
  {
     printf("No IDIO devices found \n");
     return 0;
   } 

 while (1)
 {
  switch (getFunction() ) 
  {

   case '1':
   {
      int   validInput = 0;

      validInput = 0;
      while (!validInput)
      {
       printf("  Enter data byte (hex, 0x00 - 0xFF) for port 0              : "); 
       scanf ("%x",&input);

        
       if  ( (input >=  0) && (input <= 0xFF) && (!isalnum(input)) ) 
         validInput = 1;
      else
      {
         printf("\nInvalid Input. Valid values are any hex number\n");
         validInput = 0;
      }
     } 
       data[0] = input;



      validInput = 0;
      while (!validInput)
      {
       printf("  Enter data byte (hex, 0x00 - 0xFF) for port 1              : "); 
       scanf ("%x",&input);

       if  ( (input >=  0) && (input <= 0xFF) && (!isalnum(input)) ) 
         validInput = 1;
       else
       {
         validInput = 0;
         printf("\nInvalid Input. Valid values are any hex number\n");
        }
    }
      data[1] = input;


      ret = AIO_Usb_WriteAll(devIdx,
                             (unsigned char *)&data[0]);


      if (ret > ERROR_SUCCESS)
      {
        printf ("\n\nDIO_WriteAll : Failed dev=0x%0x err=%d  \n\n",(unsigned int)devIdx,ret);
        break;
      }

     break;
    }

   case '2':
   {

      data[0] = 0;
      data[1] = 0;
      data[2] = 0;
      data[3] = 0;
      ret =   AIO_Usb_DIO_ReadAll (devIdx,
                                   (unsigned char *)&data[0]); 

      if (ret > ERROR_SUCCESS)
      {
        printf ("\n\nReadAll Failed dev=0x%0x err=%d  \n\n",(unsigned int)devIdx,ret);
        break;
      }


      printf("\t\tPort 0 :  0x%x\n",data[0]);
      printf("\t\tPort 1 :  0x%x\n",data[1]);
      printf("\t\tPort 2 :  0x%x\n",data[2]);
      printf("\t\tPort 3 :  0x%x\n",data[3]);

      printf("\n");
      printf("  Presss the ANY key to continue ");
      key  = getchar(); 
      key  = getchar(); 
      break;
    }

   case '3':
   {
     return 0; 
   }
   default :
    break;
  } 

  } // while 

  } // main 
