/*
 * inw.c  ---  User mode program to read a word from an I/O port.
 *
 *
 * Copyright 1999 Illinois Institute of Technology
 *
 * See the file "LICENSE" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 */


#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <asm/types.h>

#include "portio.h"

int
main( int argc, char *argv[] )
{
	int fd, status;
	__u16 address;
	__u16 value;

	char usage[] = "Usage: inw address\n";

	if ( argc == 2 ) {
		address = strtoul( argv[1], NULL, 0 );
	} else {
		fputs( usage, stderr );
		exit(1);
	}

	fd = open( PORTIO_DEVICE, O_RDONLY );

	if ( fd == (-1) ) {
		perror( "inw: open failed" );
		exit(1);
	}

	status = portio_inw( fd, &value, address );

	if ( status == (-1) ) {
		perror( "inw: portio_inw failed" );
		exit(1);
	}

	printf( "%#04x\n", value );

	exit(0);
}

