/*
 * outw.c  ---  User mode program to write a word to an I/O port.
 *
 *
 * Copyright 1999 Illinois Institute of Technology
 *
 * See the file "LICENSE" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <asm/types.h>

#include "portio.h"

int
main( int argc, char *argv[] )
{
	int fd, status;
	__u16 address;
	__u16 value;

	char usage[] = "Usage: outw address value\n";

	if ( argc == 3 ) {
		address = strtoul( argv[1], NULL, 0 );
		value = strtoul( argv[2], NULL, 0 );
	} else {
		fputs( usage, stderr );
		exit(1);
	}

	fd = open( PORTIO_DEVICE, O_WRONLY );

	if ( fd == (-1) ) {
		perror( "outw: open failed" );
		exit(1);
	}

	status = portio_outw( fd, value, address );

	if ( status == (-1) ) {
		perror( "outw: portio_outw failed" );
		exit(1);
	}

	exit(0);
}

