/*
 *   This checks for the proper installation of the linux-kernel
 *   sources, needed to make a module.
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/utsname.h>
#include <unistd.h>
int main(void);
static const char inc[]="/usr/include/linux";
int main()
{
    struct utsname uts;
    (void)uname(&uts);
    if(access(INC, F_OK) != 0)
    {
        printf("\tThe kernel sources for this kernel version are not\n");
        printf("\tinstalled as /usr/src/linux-%s as required.\n", uts.release);
        printf("\tPlease fix this and try again.\n");
        if(access(inc, F_OK) == 0)
        {
            printf("\tYour 'C' include directory contains %s\n", inc);
            printf("\twhich might allow compilation, but all bets are off!\n");
            printf("\tExecute `make` again to gamble...\n");
        }
        exit(EXIT_FAILURE); 
    }
    return 0;
}

